//------------------------------------------------------------------------------
// <copyright file="CSSqlFunction.cs" company="Microsoft">
//     Copyright (c) Microsoft Corporation.  All rights reserved.
// </copyright>
//------------------------------------------------------------------------------
using System;
using System.Data;
using System.Data.SqlClient;
using System.Data.SqlTypes;
using Microsoft.SqlServer.Server;

public partial class UserDefinedFunctions
{
    [Microsoft.SqlServer.Server.SqlFunction(
        IsDeterministic=true,
        IsPrecise=true,
        SystemDataAccess=SystemDataAccessKind.None)]
    public static SqlInt32 EvenNumberCLR(SqlInt32 id)
    {
        return new SqlInt32((id % 2 == 0)?1:0);
    }

    [Microsoft.SqlServer.Server.SqlFunction(
        IsDeterministic=true,
        IsPrecise=true,
        SystemDataAccess=SystemDataAccessKind.Read)]
    public static SqlInt32 EvenNumberCLRWithDataAccess(SqlInt32 id)
    {
        return new SqlInt32((id % 2 == 0) ? 1 : 0);
    }

    [Microsoft.SqlServer.Server.SqlFunction(IsDeterministic = true, IsPrecise = true, SystemDataAccess = SystemDataAccessKind.None)]
    public static SqlByte LikeCLR(SqlString value, SqlString predicate)
    {
        if (value.IsNull || predicate.IsNull)
            return new SqlByte(0);
        else
            if (value.ToString().Contains(predicate.ToString()))
                return new SqlByte(1);
            else
                return new SqlByte(0);
    }

    [Microsoft.SqlServer.Server.SqlFunction(
        IsDeterministic = true, 
        IsPrecise = false, 
        SystemDataAccess = SystemDataAccessKind.None)]
    public static SqlDouble CalcDistanceCLR(
        SqlDouble fromLat,
        SqlDouble fromLon,
        SqlDouble toLat,
        SqlDouble toLon)
    {
        double fromLatR =  Math.PI / 180 * fromLat.Value;
        double fromLonR = Math.PI / 180 * fromLon.Value;
        double toLatR = Math.PI / 180 * toLat.Value;
        double toLonR = Math.PI / 180 * toLon.Value;
        return new SqlDouble( 2 * Math.Asin(
				Math.Sqrt(
					Math.Pow(Math.Sin((fromLatR - toLatR) / 2.0),2) +
					(
						Math.Cos(fromLatR) * Math.Cos(toLatR) * 
                            Math.Pow(Math.Sin((fromLonR - toLonR) / 2.0),2)
					)
				)
			) * 20001600.0 / Math.PI);
    }


}
